﻿using DistributedGA.Core;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DistributedGA.Operator.Interface
{
    /// <summary>
    /// Is used within a GA-Instance to be able to apply changes on internal population during the GA's lifecycle
    /// </summary>
    public interface IMigrationOperator
    {
        void Init();

        void Apply(Solution[] population); //Applies population on GA's internal population

        SolutionInfo[] GetMigrationInfo(); //Get populations from the peer-to-peer network

        void PublishMigrationInfo(SolutionInfo[] population); //Send population into the peer-to-peer network
    }
}
